function Create(self)
	self.actionPhase = 0;
	self.Module = nil
	self.stuck = false;
	self.LifeTimer = Timer()
	self.LifeTimer:Reset()
end

function Update(self)
	if self.actionPhase == 0 then
		local rayHitPos = Vector(0,0);
		local rayHit = false;
		for i = 1, 15 do
			local checkPos = self.Pos + Vector(self.Vel.X,self.Vel.Y):SetMagnitude(i);
			local checkPix = SceneMan:GetMOIDPixel(checkPos.X,checkPos.Y);
			if checkPix ~= 255 then		
				checkPos = checkPos + SceneMan:ShortestDistance(checkPos,self.Pos,SceneMan.SceneWrapsX):SetMagnitude(3);
				self.target = MovableMan:GetMOFromID(checkPix);
				self.stickpositionX = checkPos.X-self.target.Pos.X;
				self.stickpositionY = checkPos.Y-self.target.Pos.Y;
				self.stickrotation = self.target.RotAngle;
				self.stickdirection = self.RotAngle;
				self.stuck = true;
				rayHit = true;
				break
			end
		end
		if rayHit == true then
			self.actionPhase = 1;
		else
			if SceneMan:CastStrengthRay(self.Pos,Vector(self.Vel.X,self.Vel.Y):SetMagnitude(15),0,rayHitPos,0,0,SceneMan.SceneWrapsX) == true then
				self.Pos = rayHitPos + SceneMan:ShortestDistance(rayHitPos,self.Pos,SceneMan.SceneWrapsX):SetMagnitude(3);
				self.PinStrength = 1000;
				self.AngularVel = 0;
				self.stuck = true;
				self.actionPhase = 2;
			end
		end
	elseif self.actionPhase == 1 then
		if self.target ~= nil and self.target.ID ~= 255 then
			self.Pos = self.target.Pos + Vector(self.stickpositionX,self.stickpositionY):RadRotate(self.target.RotAngle-self.stickrotation);
			self.RotAngle = self.stickdirection+(self.target.RotAngle-self.stickrotation);
			self.PinStrength = 1000;
			self.Vel = Vector(0,0);
			-----------------------
			for i = 0, (PresetMan:GetTotalModuleCount()-1) do
				self.TempModule = PresetMan:GetEntityDataLocation(self.target.ClassName, self.target.PresetName, i)
				local number1, number2 = string.find(self.TempModule, ".rte")
				if number2 ~= nil then						
					local TempModule = string.sub(self.TempModule, 1, number2)
					self.Module = TempModule
				end
			end
			if self.Sharpness == 0 then
				Team1Module = self.Module
				--print(self.Module)
			elseif self.Sharpness == 1 then
				Team2Module = self.Module
			elseif self.Sharpness == 2 then
				Team3Module = self.Module
			elseif self.Sharpness == 3 then
				Team4Module = self.Module
			end
			-----------------------
		else
			self.PinStrength = 0;
			self.actionPhase = 0;
			self.ToDelete = true
		end
	end
	
	if self.LifeTimer:IsPastRealMS(2500) then
		--print(self.Module)
		if self.Module == nil then
			if self.Sharpness == 0 then
				Team1Module = nil
			elseif self.Sharpness == 1 then
				Team2Module = nil
			elseif self.Sharpness == 2 then
				Team3Module = nil
			elseif self.Sharpness == 3 then
				Team4Module = nil
			end		
		end
	end
end